DEFINE_EXECUTE_AT_END(JudgeResidual)
{
	real ContinuityRes = 0;  //Residuals for continuous equations
	Domain *domain = Get_Domain(1);
	for (int i = 0; i < DOMAIN_NUMEQN(domain); i++)
	{
		int eqn = DOMAIN_EQNS(domain, i); //Equation number
		CString strEqnLabel = DOMAIN_EQN_LABEL(domain, eqn); //Get the name of the equation
		if (!strEqnLabel.IsEmpty())  //If the equation name is not empty
		{
			if (0 == DOMAIN_RES_SCALE(domain, i))
				DOMAIN_RES_SCALE(domain, i) = 1.0;//Preventing the denominator from being zero
			real scaled_res = DOMAIN_RES(domain, i) / DOMAIN_RES_SCALE(domain, i); //Getting the residuals
			if (0 == strEqnLabel.CompareNoCase("continuity")) //If it is a continuous equation, assign the residuals to ContinuityRes
				ContinuityRes = scaled_res;
		}
	}

	Message0("Continuity Equation Scaled Residual= %e \n", ContinuityRes); //Print to Fluent Console

	if (N_ITER <= 1)  //The residuals of the 1st time may be 0, and the iteration continues without considering the residuals
	{
		Message0("1st iteration, Continue to iterate\n");
		SuperUdf_Steady_Iterate(1);  //Perform the next iteration
	}
	else if (N_ITER > 1 && ContinuityRes > CONTINUITY_RESIDUAL_TO_STOP) 
		//The 2nd iteration starts to re-examine whether the residuals are greater than the set value, if they are greater then continue the iteration
	{
		Message0("Residual> %g, Continue to iterate\n", CONTINUITY_RESIDUAL_TO_STOP);
		SuperUdf_Steady_Iterate(1);  //Perform the next iteration
	}
	else
		Message0("Residual<= %g, stop iteration\n", CONTINUITY_RESIDUAL_TO_STOP);
}
